#!/bin/sh

#
# Copyright (c) 2008 Peter Holm
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: backingstore.sh,v 1.2 2008/02/25 16:31:42 pho Exp $
#

# Test sparse backing store

[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1

. ../default.cfg

D=$DISKIMAGE
export here=`pwd`

m=$MDSTART

mount | grep "${MNTPOINT}" | grep -q md$m && umount ${MNTPOINT}$m
mdconfig -l | grep -q md$m &&  mdconfig -d -u $m

dede $D$m 100m 1 || exit 1

mdconfig -a -t vnode -f $D$m -u $m

disklabel -r -w md$m auto
newfs md${m}c > /dev/null 2>&1
mount $opt /dev/md${m}c ${MNTPOINT}$m

n=$m
m=$((m + 1))

mount | grep "${MNTPOINT}" | grep -q md$m && umount ${MNTPOINT}$m
mdconfig -l | grep -q md$m &&  mdconfig -d -u $m

truncate -s 500M ${MNTPOINT}$n/diskimage
mdconfig -a -t vnode -f ${MNTPOINT}$n/diskimage -u $m

disklabel -r -w md$m auto
newfs md${m}c > /dev/null 2>&1
mount $opt /dev/md${m}c ${MNTPOINT}$m

export RUNDIR=${MNTPOINT}$m/stressX
../testcases/rw/rw -t 5m -i 200 -h -n

while mount | grep -q ${MNTPOINT}$m; do
	flag=$([ $((`date '+%s'` % 2)) -eq 0 ] && echo "-f" || echo "")
	umount $flag ${MNTPOINT}$m > /dev/null 2>&1
done
mdconfig -l | grep -q md$m &&  mdconfig -d -u $m

m=$((m - 1))
while mount | grep -q ${MNTPOINT}$m; do
	umount $([ $((`date '+%s'` % 2)) -eq 0 ] && \
		echo "-f" || echo "") ${MNTPOINT}$m > /dev/null 2>&1
done
mdconfig -l | grep -q md$m &&  mdconfig -d -u $m
rm -d $D
