#!/bin/sh

#
# Copyright (c) 2008 Peter Holm
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: msdos.sh,v 1.3 2008/05/10 18:45:50 pho Exp $
#

[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1

# Causes this: panic: mutex Giant not owned at ../../../kern/vfs_subr.c:1968
# with a kernel compiled with "options QUOTA"

. ../default.cfg

unmount() {
	while mount | grep mnt | grep -q md${MDSTART}; do
		umount $MNTPOINT > /dev/null 2>&1
	done
}

D=$DISKIMAGE
dede $D 1m 128 || exit 

unmount
mdconfig -l | grep ${MDSTART} > /dev/null &&  mdconfig -d -u $MDSTART

mdconfig -a -t vnode -f $D -u $MDSTART

bsdlabel -w md${MDSTART} auto
newfs_msdos -F 16 -b 8192 /dev/md${MDSTART}a
mount -t msdosfs /dev/md${MDSTART}a $MNTPOINT
df -h $MNTPOINT
export RUNDIR=$MNTPOINT/stressX
#export CNTRLDIR/tmp/stressX.ctrl
export runRUNTIME=10m            # Run tests for 10 minutes
(cd /home/pho/stress2; ./run.sh disk.cfg) 
unmount
mdconfig -d -u $MDSTART
rm -f $D
