#!/bin/sh

#
# Copyright (c) 2008 Peter Holm
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: newfs.sh,v 1.2 2008/02/25 16:31:43 pho Exp $
#

[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1

D=/usr/tmp/diskimage
truncate -s 128M $D

mount | grep "/mnt" | grep md0c > /dev/null && umount /mnt
mdconfig -l | grep md0 > /dev/null &&  mdconfig -d -u 0

mdconfig -a -t vnode -f $D -u 0
disklabel -r -w md0 auto

blocksize=4096

while [ $blocksize -le 65536 ]; do
	for i in 8 4 2 1; do
		fragsize=$((blocksize / i))
		echo "newfs -b $blocksize -f $fragsize -U md0c"
		newfs -b $blocksize -f $fragsize    md0c > /dev/null
		mount /dev/md0c /mnt
		export RUNDIR=/mnt/stressX
		export runRUNTIME=10m            # Run tests for 10 minutes
		(cd /home/pho/stress2; ./run.sh disk.cfg) 
		false
		while [ $? -ne 0 ]; do
                        umount /mnt > /dev/null 2>&1
                done

	done
	blocksize=$((blocksize * 2))
done
mdconfig -d -u 0
rm -f $D
