#!/bin/sh

#
# Copyright (c) 2008 Peter Holm
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: quota4.sh,v 1.2 2008/02/25 16:31:44 pho Exp $
#

[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1

# Has shown a deadlock after 7 hours of testing

. ../default.cfg

D=$DISKIMAGE
trap "rm -f $D" 0
dede $D 1m 1k || exit 1

mount | grep "${MNTPOINT}" | grep md${MDSTART}c > /dev/null && umount ${MNTPOINT}
mdconfig -l | grep md${MDSTART} > /dev/null &&  mdconfig -d -u ${MDSTART}

mdconfig -a -t vnode -f $D -u ${MDSTART}
disklabel -r -w md${MDSTART} auto
newfs -U  md${MDSTART}c > /dev/null
echo "/dev/md${MDSTART}c ${MNTPOINT} ufs rw,userquota 2 2" >> /etc/fstab
mount ${MNTPOINT}
edquota -u -f ${MNTPOINT} -e ${MNTPOINT}:850000:900000:130000:140000 root > /dev/null 2>&1
quotaon ${MNTPOINT}
sed -i -e "/md${MDSTART}c/d" /etc/fstab	# clean up before any panics
export RUNDIR=${MNTPOINT}/stressX
../testcases/rw/rw -t 2m -i 200 -h -n -v -v&
sleep 60
false
while mount | grep -q ${MNTPOINT}; do
	umount $([ $((`date '+%s'` % 2)) -eq 0 ] && echo "-f" || echo "") ${MNTPOINT} > /dev/null 2>&1
done
mdconfig -d -u ${MDSTART}
rm -f $D
