/* $FreeBSD$ */

/* Cleanup utility for deleting deep directories created by mkdir */

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <errno.h>
#include <string.h>
#include <err.h>

static int max;
char help[2048];

void
rmDir(char *path, int level) {
	char newPath[10];

	if (level < max) {
		sprintf(newPath,"d%d", level+1);
		rmDir(newPath, level+1);
	}
	chdir ("..");
	if (rmdir(path) == -1) {
		err(1, "rmdir %s(%s:%d)", path, __FILE__, __LINE__);
		exit(2);
	}
}

void
rmDir2(char *path, int level) {
	char newPath[10];

	chdir(path);
	sprintf(newPath,"d%d", level+1);
	if (access(newPath, R_OK) == 0) 
		rmDir2(newPath, level+1);
	chdir ("..");
	if (rmdir(path) == -1) {
		warn("rmdir %s (%s:%d)", path, __FILE__, __LINE__);
//		sprintf(help, "ls -l %s", path);
//		system(help);
		sprintf(help, "rm -f %s/*.core", path);
		system(help);
	}
}

int
main(int argc, char **argv) {

	int n;
	char cmd[256];
	char buf[256];
	FILE *fd;

	if (getenv("RUNDIR") == NULL) {
		fprintf(stderr, "The RUNDIR environment variable must be set!\n");
		return (1);
	}
	snprintf(cmd, sizeof(cmd), "ls %s | egrep 'p[0-9]*.d1'", getenv("RUNDIR"));
	fd = popen(cmd, "r");
	while (fgets(buf, sizeof(buf), fd) > 0) {
		n = strlen(buf);
		if (n > 0)
			buf[--n] = 0;
		snprintf(cmd, sizeof(cmd), "%s/%s", getenv("RUNDIR"), buf);
		printf("delete %s\n", cmd);
		rmDir2(cmd, 1);
	}
	pclose(fd);

	return 0;
}
