#!/bin/sh

#
# Copyright (c) 2008 Peter Holm
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: unionfs3.sh,v 1.2 2008/02/25 16:31:44 pho Exp $
#

[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1

# Test with interchanged arguments to mount_unionfs
# Causes page fault in vfs_mount.c:1975

D=/usr/tmp/diskimage
truncate -s 256M $D

mount | grep "/mnt" | grep md0c > /dev/null && umount /mnt
mdconfig -l | grep md0 > /dev/null &&  mdconfig -d -u 0

mdconfig -a -t vnode -f $D -u 0
disklabel -r -w md0 auto
newfs -U  md0c > /dev/null
mount /dev/md0c /mnt
mount -t unionfs -o noatime /tmp /mnt
umount -f /tmp	# panic
mount /tmp
mount | grep "/mnt" | grep md0c > /dev/null && umount    /mnt
mount | grep "/mnt" | grep md0c > /dev/null && umount -f /mnt
mdconfig -d -u 0
rm -f $D
